;#include <Array.au3> 
#include <PluginHelpers.au3> 

#NoTrayIcon

If $CmdLine[0] = 0 Then
	ConsoleWrite("No parameters given." & @CRLF & @CRLF & "Syntax: " & @ScriptName & " plugin.wdx [testfile column [unit]]" & @CRLF)
	Exit
EndIf

Global $hPlugin = 0
Global $sPluginName = $CmdLine[1]
Global $sFileName = ""
Global $nFieldIdx = 0
Global $nUnitIdx = 0

If Not FileExists($sPluginName) Then 
    ConsoleWrite("Plugin file is not exists.")
    Exit
EndIf

$hPlugin = _PHWDXPluginOpen($sPluginName)
If @error Then Exit

Opt("OnExitFunc", "ExitFunc")

$aFields = _PHWDXGetFields($hPlugin)

;_ArrayDisplay($aFields)

If $CmdLine[0] = 1 Then 
    ConsoleWrite("All columns: " & @CRLF & @CRLF)
    For $i = 0 To UBound($aFields) - 1
        ConsoleWrite("[" & $i & "] -> " & $aFields[$i][$FIELD_NAME] & @CRLF)
    Next
    Exit
EndIf

If $CmdLine[0] >= 3 Then
    $sFileName = $CmdLine[2]
    $nFieldIdx = $CmdLine[3]
Else
    ConsoleWrite("Not enough parameters." & @CRLF)
    Exit
Endif

If Not FileExists($sFileName) Then 
    ConsoleWrite("Test file not exists.")
    Exit
EndIf

If $CmdLine[0] = 4 Then $nUnitIdx = $CmdLine[4]

$sValue = _PHWDXGetValue($hPlugin, $sFileName, $nFieldIdx, $nUnitIdx)

; Чтобы обойти ограничения вывода в консоль, преобразуем юникодную строку
; в бинарные данные, содержащие строку UTF-8
$bValue = StringToBinary($sValue, 4)

ConsoleWrite($bValue)

Func ExitFunc()
    _PHWDXPluginClose($hPlugin)
EndFunc